#define IN1 9 // Připojení výstupních pinů ke vstupům driveru
#define IN2 8
#define IN3 7
#define IN4 6
#define ENA 10 // Pin pro aktivaci motoru A
#define ENB 5  // Pin pro aktivaci motoru B

#define L_LINE_PIN A0 // Levý senzor čáry je připojen k pinu A0
#define M_LINE_PIN A1 // Prostřední senzor čáry je připojen k pinu A1
#define R_LINE_PIN A2 // Pravý senzor čáry je připojen k pinu A2

int speed = 100; // proměnná pro rychlost motorů, hodnoty od 0 do 255

void setup(){ 
    pinMode(IN1, OUTPUT); // Nastaví piny pro ovládání motorů jako výstupy
    pinMode(IN2, OUTPUT);
    pinMode(IN3, OUTPUT);
    pinMode(IN4, OUTPUT);
    pinMode(ENA, OUTPUT);
    pinMode(ENB, OUTPUT);

    pinMode(L_LINE_PIN, INPUT); // Nastaví piny se senzory jako vstupní
    pinMode(M_LINE_PIN, INPUT);
    pinMode(R_LINE_PIN, INPUT);
}

void loop(){
    bool leftLine = digitalRead(L_LINE_PIN); // Do proměnných se zapíšou výstupní hodnoty ze senzorů
    bool midLine = digitalRead(M_LINE_PIN);
    bool rightLine = digitalRead(R_LINE_PIN);

    if(midLine == HIGH){ // Pokud střední senzor detekuje čáru
        if(leftLine == LOW & rightLine == HIGH){ // Pokud je zároveň bílá na levém a černá na pravém
            right(); // Zatočí doprava
        }else if(rightLine == LOW & leftLine == HIGH){ // Pokud je zároveň černá na levém a bílá na pravém
            left(); // Zatočí doleva
        }else{ // V ostatních případech
            forward();
        }
    }else{ // middle sensor on white area
        if(leftLine == LOW & rightLine == HIGH){ // black on left, white on right, turn left
            right();
        }else if(rightLine == LOW & leftLine == HIGH){ // white on left, black on right, turn right
            left();
        }else{ // all white, stop
             back();
             delay(100); 
         }
    }    
}

void forward(){ // Funkce pro jízdu dopředu
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void back(){ // Funkce pro jízdu dozadu
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void left(){ // Funkce pro zatáčení doleva
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void right(){ // Funkce pro zatáčení doprava
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void stop(){ // Funkce pro zastavení robota
  digitalWrite(ENA, LOW);
  digitalWrite(ENB, LOW);
}
