#include <SR04.h>  // Knihovna pro ultrazvuk
#include <Servo.h> // Knihovna pro servo

#define SERVO_PIN 11 // Servo je připojeno k pinu 11

#define TRIG_PIN 3 // Pin trigger je připojen k pinu 3 Arduina
#define ECHO_PIN 2 // Pin echo je připojen k pinu 2 Arduina

#define IN1 9 // Připojení výstupních pinů ke vstupům driveru
#define IN2 8
#define IN3 7
#define IN4 6
#define ENA 10 // Pin pro aktivaci motoru A
#define ENB 5  // Pin pro aktivaci motoru B


Servo myservo;  // Vytvoří objekt typu Servo
SR04 sr04 = SR04(ECHO_PIN, TRIG_PIN); // Vytvoří objekt SR04

long distance; // Proměnná pro uchování vzdálenosti
const int limit 40;

void setup(){ 
    myservo.attach(SERVO_PIN);  // Připojí servo k pinu 11

    pinMode(IN1, OUTPUT); // Nastaví piny pro ovládání driveru jako výstupy
    pinMode(IN2, OUTPUT);  
    pinMode(IN3, OUTPUT);
    pinMode(IN4, OUTPUT);
    pinMode(ENA, OUTPUT);
    pinMode(ENB, OUTPUT);
}

void loop(){
    distance = sr04.Distance(); // Změří vzdálenost a zapíše ji do proměnné distance
    if(distance > limit){  // Pokud je vzdálenost větší než limit
        forward(); // Jede dopředu
    }else{
        delay(60); // počká 60 milisekund
        distance = sr04.Distance(); // Změří vzdálenost a zapíše ji do proměnné distance
        if(distance > limit){  // Pokud je vzdálenost větší než limit
            forward();  // Jede dopředu
        }else{
            stop(); // Zastaví
            myservo.write(20); // Nastaví servo do pozice 20°
            delay(500); // Počká 500 milisekund
            distance = sr04.Distance(); // Změří vzdálenost a zapíše ji do proměnné distance
            if(distance > limit){  // Pokud je vzdálenost větší než limit
                myservo.write(90); // nastaví servo do pozice 90°
                delay(500); // Počká 500 milisekund
                right();    // Zatočí doprava
                delay(300); // Počká 300 milisekund
                stop();     // Zastaví
            }else{
                myservo.write(150); // Nastaví servo do pozice 150°
                delay(500);         // Počká 500 milisekund
                distance = sr04.Distance(); // Změří vzdálenost a zapíše ji do proměnné distance
                if(distance > limit){  // Pokud je vzdálenost větší než limit
                    myservo.write(90); // Nastaví servo do pozice 90°
                    delay(500);  // Počká 500 milisekund
                    left();      // Zatočí doleva
                    delay(300);  // Počká 300 milisekund
                    stop();      // Zastaví
                }else{
                    myservo.write(90); // Nastaví servo do středové pozice
                    delay(500);  // Počká 500 milisekund
                    right();     // Zatočí doprava
                    delay(600);  // Počká 300 milisekund
                    stop();      // Zastaví
                }
            }
        }
    }
}


void forward(){ // Funkce pro jízdu dopředu
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
}

void back(){ // Funkce pro jízdu dozadu
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
}

void left(){ // Funkce pro zatáčení doleva
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
}

void right(){ // Funkce pro zatáčení doprava
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
}

void stop(){ // Funkce pro zastavení robota
  digitalWrite(ENA, LOW);
  digitalWrite(ENB, LOW);
}
